using System;
using RomeScriptInterfaces;
using Scripts;

namespace Scripts
{
    [Serializable]
	public class IceniQueenNovice : ScriptServer.IScript
    {
        // for our messaging
        private String msgTitle, msgText, msgSound2;
        private String msgSound = "message1.mp3";
        private String msgApplause = "/../../sounds/events/event_circus_01.wav";
        private String msgRiot = "/../../sounds/events/event_coliseum_05.wav";

        // variables for current ratings
        private uint nFavor, nSecurity, nCulture, nProsperity, nBeauty, uBeauty;
        private uint eFavor, eSecurity, eCulture, eProsperity, eBeauty, eWine, eFurniture, eUtensils, eLuxury, eWC1, eWC2;
        private uint uDes, uUndes, uGovBR, uRelBR, uPatBR, uEntBR, uOtherBR, uSmallST, uMediumST, uLargeST, uTree1, uTree2, uBush, uGarden, uDeco, uTHB;
        private uint oldFavor = 36;
        private uint maxFavor = 0;
        private uint rFavor = 0;
        private Int32 nPopulation, nCityFunds, nSavings;
        private Int32 eSavings, eWC3;

        // flags to tell us whether specific events have happened
        private bool bMessageSent = false;
        private bool[] bEmptyVenue = { false, false, false, false };
        private bool bInit = false;
        private bool bKablooey = false;
        private bool bPrefect = false;
        private bool bMango = false;
        private bool bIgorus = false;
        private bool bSyebe = false;
        private bool bFrog = false;
        private bool bJulius = false;
        private bool bSeutonius = false;
        private bool bDebtWarn = false;
        private bool bGraceWarn = false;
        private bool bGrace = false;
        private bool bNewRoutes = false;
        private bool bBelaches = false;
        private bool bSweep = false;
        private bool bBeauty = true;
        private bool bScored = false;
        
        private string[] sPlace = { "", "Icenorum", "Icenorum", "Belgarum", "Belgarum", "Ratae", "Ratae", "Viruconium", "Viruconium" };
        private uint[] iState = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        private uint[] tState = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        private uint iPalace = 0;
        private uint kIcenorum = 2;
        private uint kBelgarum = 4;
        private uint kRatae = 6;
        private uint kViruconium = 8;
        private uint kBelgica = 10;
        private uint kLugdunensis = 11;
        private uint kAramannopolis = 12;
        private uint kDefeat = 16;
        
        // variables for wage and population checks
        private Int32 nWageTrigger = 10000;        // first raise when city funds reach this level
        private int nPlebWages = 0;                // starting wages for plebs
        private int nEquiteWages = 0;             // ...and equites

        // variables for different checks
        private uint nTime = 0;                    // derived from game.GameTime
        private uint tWageCheck = 960;             // check after a year
        private uint tTaxCheck = 150;              // check after 6 months
        private uint tEggCheck = 480;              // first easter egg check
        private uint tSMonthStart = 5960;
        private uint tSMonthEnd = 6040;
        private uint tFMonthStart = 6120;
        private uint tFMonthEnd = 6200;
        private uint tVillaCheck = 120;            // for the check on limiting villas & Boudicca's palace
        private uint tBeautyCheck = 5615;            // every week, just before its end
        private uint tUICheck = 160;
        private uint tMango = 200;
        private uint tCommodus = 240;
        private uint iCommodus = 1;
        private uint iTax = 0;
        private uint nRoutes = 0;
        private uint tRoutes = 8000;
        private uint iBurn = 0;
        private uint iInvasions = 1;               // index into invasions
        private uint tInvasions = 360;             // first warning 
        private uint tTargetSwitch = 0;
        private uint tSwitch = 5440;               // time of the "tipping point", after Boudicca's suicide
        private uint tGrace = 5920;                // 6 months to demonstrate progress
        private uint tGraceWarn = 5840;            // warning that Nero's patience grows thin
        private uint nInvasion = 0;                
        private uint[] nTimerCheck = { 360, 840, 1800, 2760, 3720, 4680, 5640, 6120, 6600, 7080, 7320, 7400, 7480, 9999999 };
        private String[] sTimeLeft = { "90", "84", "72", "60", "48", "36", "24", "18", "12", "6", "3", "2", "1", "X" };
        private uint iMessage = 0;
        private uint tLuxury = 80;
        private uint iLuxury = 0;
        private uint maxLuxury = 128; 

        // resource IDs
        private Int32 mIDClay = IDMaker.FromString("c4cr Clay");
        private Int32 mIDIron = IDMaker.FromString("c4cr Iron");
        private Int32 mIDTimber = IDMaker.FromString("c4cr Timber");
        private Int32 mIDWine = IDMaker.FromString("c4cr Wine");
        private Int32 mIDFurniture = IDMaker.FromString("c4cr Furniture");
        private Int32 mIDUtensils = IDMaker.FromString("c4cr Utensils");
        
        // building IDs
        private Int32 mIDPalace1 = IDMaker.FromString("C4b Governor's Palace Small");
        private Int32 mIDPalace2 = IDMaker.FromString("C4b Governor's Palace Medium");
        private Int32 mIDPalace3 = IDMaker.FromString("C4b Governor's Palace Large");
        
        private Int32 mIDDomus1 = IDMaker.FromString("C4b Equites Housing 01");
        private Int32 mIDDomus2 = IDMaker.FromString("C4b Equites Housing 02");
        private Int32 mIDDomus3 = IDMaker.FromString("C4b Equites Housing 03");
        private Int32 mIDInsula1 = IDMaker.FromString("C4b Plebian home 01");
        private Int32 mIDInsula2 = IDMaker.FromString("C4b Plebian home 02");
        private Int32 mIDInsula3 = IDMaker.FromString("C4b Plebian home 03");
        private Int32 mIDEstate2 = IDMaker.FromString("C4b Patrician home 05");
        private string[] sPatricians = {"C4b Patrician home 01","C4b Patrician home 02","C4b Patrician home 03",
             "C4b Patrician home 04","C4b Patrician home 05","C4b Patrician home 06","C4b Patrician home 07",
             "C4b Patrician home 08","C4b Patrician home 09"};

        private Int32 mIDIronMine = IDMaker.FromString("C4b harvester Iron miners house");
        private Int32 mIDTimberCamp = IDMaker.FromString("C4b harvester Timber miller's house");
        private Int32 mIDClayCamp = IDMaker.FromString("C4b harvester Clay collector's house");
        private Int32 mIDVegetableFarm = IDMaker.FromString("C4b harvester Vegetable farmer's house");
        private Int32 mIDCattleFarm = IDMaker.FromString("C4b harvester Livestock farmer's house");
        private Int32 mIDSheepFarm = IDMaker.FromString("C4b harvester Wool farmer's house");
        private Int32 mIDPotteryFactory = IDMaker.FromString("C4b factory Pottery");
        private Int32 mIDClothingFactory = IDMaker.FromString("C4b factory Clothing");
        private Int32 mIDWineFactory = IDMaker.FromString("C4b factory Wine");
        private Int32 mIDFurnitureFactory = IDMaker.FromString("C4b factory Furniture");
        private Int32 mIDUtensilsFactory = IDMaker.FromString("C4b factory Utensils");
        //government
        private Int32 mIDEngineer = IDMaker.FromString("C4b Office Engineer");
        private Int32 mIDPrefect = IDMaker.FromString("C4b Office Praefect");
        private Int32 mIDTaxOffice = IDMaker.FromString("C4b Office Tax Collector");
        private Int32 mIDForum = IDMaker.FromString("C4b service Forum");
        private Int32 mIDBasilica = IDMaker.FromString("C4b service Basilica");
        //markets
        private Int32 mIDFoodMarket = IDMaker.FromString("C4b Market Food");
        private Int32 mIDBasicMarket = IDMaker.FromString("C4b market Common");
        private Int32 mIDLuxuryMarket = IDMaker.FromString("C4b Market Luxury");
        private Int32 mIDExoticMarket = IDMaker.FromString("C4b Market Exotic");
        //storage
        private Int32 mIDGranary = IDMaker.FromString("C4b infra Granary");
        private Int32 mIDWarehouse = IDMaker.FromString("C4b infra Warehouse");
        private Int32 mIDDepot = IDMaker.FromString("C4b Depot");
        private Int32 mIDPort = IDMaker.FromString("C4b Depot with Dock");
        //healthcare
        private Int32 mIDBarber = IDMaker.FromString("C4b service Barber shop");
        private Int32 mIDBathhouse = IDMaker.FromString("C4b service Bathhouse");
        private Int32 mIDClinic = IDMaker.FromString("C4b service Clinic");
        private Int32 mIDHospital = IDMaker.FromString("C4b service Hospital");
        //religion
        private Int32 mIDJupiterShrine = IDMaker.FromString("C4b Service Shrine Jupiter");
        private Int32 mIDJupiterTemple = IDMaker.FromString("C4b Service Temple Jupiter");
        private Int32 mIDMarsShrine = IDMaker.FromString("C4b Service Shrine Mars");
        private Int32 mIDMarsTemple = IDMaker.FromString("C4b Service Temple Mars");
        private Int32 mIDMercuryShrine = IDMaker.FromString("C4b Service Shrine Mercury");
        private Int32 mIDMercuryTemple = IDMaker.FromString("C4b Service Temple Mercury");
        private Int32 mIDBacchusTemple = IDMaker.FromString("C4b Service Temple Bacchus");
        private Int32 mIDCeresTemple = IDMaker.FromString("C4b Service Temple Ceres");
        //education
        private Int32 mIDSchool = IDMaker.FromString("C4b service School");
        private Int32 mIDLibrary = IDMaker.FromString("C4b service Library");
        //entertainment
        private Int32 mIDOdeum = IDMaker.FromString("C4b service Odeum");
        private Int32 mIDTheater = IDMaker.FromString("C4b service Theater");
        private Int32 mIDArena = IDMaker.FromString("C4b service Arena");
        private Int32 mIDColiseum = IDMaker.FromString("C4b Service Coliseum");
        private Int32 mIDCircus = IDMaker.FromString("C4b service Circus");
        private Int32 mIDActor = IDMaker.FromString("C4b Training Actor");
        private Int32 mIDAnimalTrainer = IDMaker.FromString("C4b Training Animal");
        private Int32 mIDGladiator = IDMaker.FromString("C4b Training Gladiator");
        private Int32 mIDCharioteer = IDMaker.FromString("C4b Training Charioteer");
        //water stuff
        private Int32 mIDFountain = IDMaker.FromString("C4b infra Fountain");
        //
        private Int32 mIDFortArchers = IDMaker.FromString("C4b Mil Fort Auxilia");
        private Int32 mIDFortCavalry = IDMaker.FromString("C4b Mil Fort Auxilia Cavalry");
        private Int32 mIDFortHeavy = IDMaker.FromString("C4b Mil Fort Infantry Hvy");
        private Int32 mIDFortLight = IDMaker.FromString("C4b Mil Fort Infantry Lt");
        private Int32 mIDDrillYard = IDMaker.FromString("C4b Mil Drill Yard");
        private Int32 mIDArmory = IDMaker.FromString("C4b Mil Armory");
        private Int32 mIDMessHall = IDMaker.FromString("C4b Mil Mess Hall");
        private Int32 mIDArmorFactory = IDMaker.FromString("C4b factory Armor");
        private Int32 mIDWeaponsFactory = IDMaker.FromString("C4b factory Weapons");
        // 
        private Int32 mIDGarden = IDMaker.FromString("C4 Deco Garden");
        private Int32 mIDHedgeSmall = IDMaker.FromString("C4 Deco Hedge Small");
        private Int32 mIDHedgeLarge = IDMaker.FromString("C4 Deco Hedge Large");
        private Int32 mIDBushSmall = IDMaker.FromString("C4 Deco Bush Small");
        private Int32 mIDBushLarge = IDMaker.FromString("C4 Deco Bush Large");
        private Int32 mIDTreeSmall = IDMaker.FromString("C4 Deco Tree Small");
        private Int32 mIDTreeMedium = IDMaker.FromString("C4 Deco Tree Medium");
        private Int32 mIDTreeLarge = IDMaker.FromString("C4 Deco Tree Large");
        private Int32 mIDHedgeRowSmall = IDMaker.FromString("C4 Deco HedgeRow Small");
        private Int32 mIDHedgeRowLarge = IDMaker.FromString("C4 Deco HedgeRow Large");
        private Int32 mIDStatue1 = IDMaker.FromString("C4 Deco Statue 1");
        private Int32 mIDStatue2 = IDMaker.FromString("C4 Deco Statue 2");
        private Int32 mIDStatue3 = IDMaker.FromString("C4 Deco Statue 3");
        private Int32 mIDStatue4 = IDMaker.FromString("C4 Deco Statue 4");
        private Int32 mIDStatue5 = IDMaker.FromString("C4 Deco Statue 5");
        private Int32 mIDStatue6 = IDMaker.FromString("C4 Deco Statue 6");
        private Int32 mIDObelisk = IDMaker.FromString("C4b Statue Obelisk");

        // build button IDs
        private Int32 mUIIDTaxman = 276325360;
        private Int32 mUIIDOdeum = 1740942627;
        private Int32 mUIIDTheater = -137606214;
        private Int32 mUIIDActor = 1806783073;
        private Int32 mUIIDArena = 1724165050;
        private Int32 mUIIDGladiator = 1806783075;
        private Int32 mUIIDColiseum = 1691448420;
        private Int32 mUIIDCircus = -2046596977;
        private Int32 mUIIDHospital = -1282219393;
        private Int32 mUIIDBasilica = 276325373;
        private Int32 mUIIDForum = 293102951;
        private Int32 mUIIDLibrary = -1298997110;
        private Int32 mUIIDPrefect = 276325365;
        private Int32 mUIIDSchool = -1298997109;
        private Int32 mUIIDGovt = IDMaker.FromString("GOVT");
        private Int32 mUIIDPlebHome = IDMaker.FromString("PLEB_HOME");
        private Int32 mUIIDEquiteHome = IDMaker.FromString("EQUES_HOME");
        private Int32 mUIIDPatHome = IDMaker.FromString("PAT_HOME");
        private Int32 mUIIDExoticMarket = IDMaker.FromString("MARKET_EXOTIC");
        private Int32 mUIIDObelisk = IDMaker.FromString("PRESALE1");
        private Int32 mUIIDStorage = IDMaker.FromString("STORAGE");
        private Int32 mUIIDShipBridge = IDMaker.FromString("BRIDGE_SHIP");
        
        // these are here just in case we need them
        private Int32 mUIIDFortLight = IDMaker.FromString("FORT_LT");
        private Int32 mUIIDFortHeavy = IDMaker.FromString("FORT_HVY");
        private Int32 mUIIDFortCavalry = IDMaker.FromString("FORT_CAV");
        private Int32 mUIIDFortArcher = IDMaker.FromString("FORT_AUX");
        private Int32 mUIIDMessHall = IDMaker.FromString("MIL_MESS_HALL");
        private Int32 mUIIDRecruitment = IDMaker.FromString("MIL_ARMORY");
        private Int32 mUIIDDrillYard = IDMaker.FromString("MIL_DRILL_YARD");

        private Int32 mUIIDSalary = 989726645;

        // The following declarations are necessary as this scenario uses custom standard wage changes
        private StandardWageManager mWageManagerPlebe = null;
        private StandardWageManager mWageManagerEques = null;

        private TMilitaryAI mMilitaryAI = null;
        private InvasionSetup[] mInvasions;
        // This is the main script loop
        public void Run(object gameInterface)
        {
            IGameQueryInterface gameQueryInterface = (IGameQueryInterface)gameInterface;
            switch(gameQueryInterface.RunReason)
            {
                case RunReason.kTick:
                    OnTick(gameQueryInterface);
                    break;

                case RunReason.kOnBeginScenario:
                    OnBeginScenario(gameQueryInterface);
                    break;

                case RunReason.kOnInvasionArrival:
                    OnInvasionArrival(gameQueryInterface);
                    break;

                case RunReason.kOnCohortTargetDestroyed:
                    OnCohortTargetDestroyed(gameQueryInterface);
                    break;

                case RunReason.kOnLoadScenario:
                    OnScenarioLoad(gameQueryInterface);
                    break;
            }
        }

        void OnTick(IGameQueryInterface game)
        {
            if (bInit)
            {
                bInit = false;
                ResetBaseUI(game);
                game.ScriptDone = false;
            }
            else if (!bKablooey)
                KablooeyTime(game);
            else if (!bPrefect)
            {
                if (nTime > 90)
                {
                    game.UnlockUIControl(mUIIDPrefect, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDPlebHome, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDEquiteHome, Toolset.MainGameFormID);
                    bPrefect = true;
                }
            }
            else if (nTime > tUICheck)
            {
                CheckBaseUI(game);
                tUICheck = nTime + 10;
            }

            // Set our city ratings
            GetCityRatings(game);

            if ((nTime > nTimerCheck[iMessage]) && (nTime < 7560)) TimerMessage(game);

            // check for successful raids
            if (nTime > 960) CheckForRaids(game);

            // check for triggered invasions
            if (nTime > tInvasions) DoInvasionSequence(game);

            if (nTime < tSwitch)
                LimitVillas(game);
            else if (!bGrace || (nTime < tGrace))
                SwitchToRoman(game);

            // are wage expectations raised?
            if (!bMessageSent && (nTime > tWageCheck) && (nPlebWages < 24))
                CheckWageExpectations(game);
            else if ((nTime >= 600) && (nPlebWages < 8))
                SetInitialWages(game);

            if (nTime > tCommodus) CommodusStory(game);
            
            // check for Easter Eggs
            if (!bMessageSent && (nTime > tEggCheck)) CheckEasterEggs(game);
            if (!bMessageSent && bJulius) AllysSecret(game);

            // check to see if player is over-taxing (too many tax offices)
            if (!bMessageSent && (nTime > tTaxCheck)) TaxCheck(game);

            // Switch targetting
            if (game.AnyActiveInvasions && (nTime > tTargetSwitch)) UpdateTargets(game);
            oldFavor = nFavor;
        }

        /////////////////////////////////////////////
        // This is where we get the city ratings etc
        void GetCityRatings(IGameQueryInterface game)
        {
            nTime = game.GameTime / 1000;           // time measured in seconds
            game.GetFavorRating(out nFavor);
            game.GetCultureRating(out nCulture);
            game.GetSecurityRating(out nSecurity);
            game.GetProsperityRating(out nProsperity);
            game.GetPopulation(out nPopulation);
            game.GetCityFunds(out nCityFunds);
            game.GetGovernorPersonalFunds(out nSavings);
            if (nFavor > maxFavor) maxFavor = nFavor;
            if (nTime > tBeautyCheck) ShowBeautyRating(game);
            bMessageSent = false;

            if ((nRoutes == 4) && (tRoutes > 7800))
            {
                tRoutes = nTime;
                eWC1 = (tRoutes - 42) / 80 + 1;
                RouteAcclamation(game);
            }
            
            if (nTime > 7560)
            {
                if (!bScored) ScorePoints(game);
                game.ScriptDone = true;
                if (nTime > 7640) game.OpenTradeRoute(kDefeat);
            }
            else if (nCityFunds <= -4000)
            {
                game.ScriptDone = true;
                game.OpenTradeRoute(kDefeat);
            }
            else if (!bDebtWarn && (nCityFunds <= -2000))
            {
                bDebtWarn = true;
                if (nTime < tSwitch)
                    DisplayMessage(game, "Debt_Warn1");
                else
                    DisplayMessage(game, "Debt_Warn2");
            }
            else if (game.AnyActiveInvasions)
            {
                game.LockUIControl(mUIIDGovt, Toolset.MainGameFormID);
                if (nPalace(game) == 0)
                {
                    game.ScriptDone = true;
                    game.OpenTradeRoute(kDefeat);
                }
            }
            else
                game.UnlockUIControl(mUIIDGovt, Toolset.MainGameFormID);
            
        }

        ///////////////////////////////////////////////
        // Start-up town on Mona Island goes Kablooey!
        void KablooeyTime(IGameQueryInterface game)
        {
            if (nTime > 70)
            {
                game.TriggerFireDamage(mIDInsula1, 6, 91);
                game.TriggerFireDamage(mIDDomus1, 3, 89);
                game.TriggerFireDamage(mIDFoodMarket, 1, 84);
                game.TriggerFireDamage(mIDClinic, 1, 85);
                game.TriggerFireDamage(mIDJupiterShrine, 1, 87);
                game.TriggerFireDamage(mIDCeresTemple, 1, 88);
                game.TriggerFireDamage(mIDBacchusTemple, 1, 86);
                game.TriggerFireDamage(mIDOdeum, 1, 85);
                game.TriggerFireDamage(mIDTheater, 1, 85);
                game.TriggerFireDamage(mIDGranary, 1, 90);
                game.TriggerFireDamage(mIDSchool, 1, 84);
                game.TriggerFireDamage(mIDPrefect, 1, 97);
                game.TriggerFireDamage(mIDEngineer, 1, 93);
                bKablooey = true;
            }
            game.UnlockUIControl(mUIIDSalary, Toolset.AdvisorsFormID);
        }

        //////////////////////////////////////////
        // City buildings set on fire in sequence
        void CityBurns(IGameQueryInterface game)
        {
            if (iBurn == 2)
            {
                // pottery
                TorchABuilding(mIDPotteryFactory, game);
            }
            else if (iBurn == 3)
            {
                // clothing
                TorchABuilding(mIDClothingFactory, game);
            }
            else if (iBurn == 4)
            {
                // wine
                TorchABuilding(mIDWineFactory, game);
            }
            else if (iBurn == 5)
            {
                // furniture
                TorchABuilding(mIDFurnitureFactory, game);
            }
            else if (iBurn == 6)
            {
                // utensils
                TorchABuilding(mIDUtensilsFactory, game);
            }
            else if (iBurn == 7)
            {
                // weapons
                TorchABuilding(mIDWeaponsFactory, game);
            }
            else if (iBurn == 8)
            {
                // armor
                TorchABuilding(mIDArmorFactory, game);
            }
            else if (iBurn == 10)
            {
                // warehouses
                TorchABuilding(mIDWarehouse, game);
            }
            else if (iBurn == 11)
            {
                // markets
                TorchABuilding(mIDFoodMarket, game);
                TorchABuilding(mIDBasicMarket, game);
                TorchABuilding(mIDLuxuryMarket, game);
                TorchABuilding(mIDExoticMarket, game);
            }
            else if (iBurn == 12)
            {
                // plebs
                TorchABuilding(mIDInsula1, game);
                TorchABuilding(mIDInsula2, game);
                TorchABuilding(mIDInsula3, game);
            }
            else if (iBurn == 13)
            {
                // equites
                TorchABuilding(mIDDomus1, game);
                TorchABuilding(mIDDomus2, game);
                TorchABuilding(mIDDomus3, game);
            }
            else if (iBurn == 14)
            {
                // Residence
                TorchABuilding(mIDPalace1, game);
                TorchABuilding(mIDPalace2, game);
                TorchABuilding(mIDPalace3, game);
            }
            iBurn++;
        }

        ////////////////////////////////////////////////////////
        // This sets fire to a building of the specified type
        void TorchABuilding(Int32 mID, IGameQueryInterface game)
        {
            UInt32 num = 0;
            game.GetTotalBuildings(mID, out num);
            if (num > 0) game.TriggerFireDamage(mID, 1, 50);
        }

        ////////////////////////////////////////////
        // This changes invader targets
        void UpdateTargets(IGameQueryInterface game)
        {
            Int32[] enemyCohorts;
            String invasion;
            // This bit applies to the native invaders - Rome behaves like the Romans do
            String[] sTargets = { "C4b harvester Iron miners house", "C4b harvester Clay collector's house" };
            String orders = "RazeBuildings";
            tTargetSwitch = 9999999;
            if (nInvasion == 1)
            {
                invasion = "raid57AD";
                game.GetInvaderCohorts(ref invasion, out enemyCohorts);

                foreach (Int32 cohortID in enemyCohorts)
                {
                    game.SetCohortOrders(cohortID, ref orders);
                    game.SetCohortTargets(cohortID, ref sTargets);
                }
            }
        }

        //////////////////////////////////////////////
        // the continuing story of commodus
        void CommodusStory(IGameQueryInterface game)
        {
            uint nB1, nB2, nB3, num = 0;

            switch (iCommodus)
            {
                case 1:
                    DisplayMessage(game, "Commodus_Intro");
                    LogMessage(game, "Commodus_Story");
                    iCommodus++;
                    tCommodus = 400;
                    break;

                case 2:
                    DisplayMessage(game, "Commodus_School");
                    game.UnlockUIControl(mUIIDSchool, Toolset.MainGameFormID);
                    iCommodus++;
                    tCommodus = 480;
                    break;

                case 3:
                    game.GetActiveBuildings(mIDSchool, out num);
                    if (num > 0)
                    {
                        msgSound2 = "/../../../../../../../Sierra/Caesar3/wavs/missionary_exact3.wav";
                        DisplayMessage2(game, "School_Riot");
                        game.TriggerStructureDamage(mIDSchool, 1, 95);
                        iCommodus++;
                        tCommodus = nTime + 240;
                    }
                    else
                        tCommodus += 40;
                    break;

                case 4:
                    DisplayMessage(game, "Commodus_Timber");
                    iCommodus++;
                    tCommodus = nTime + 80;
                    break;

                case 5:
                    game.GetResource(mIDTimber, out num);
                    if (num >= 32)
                    {
                        game.TriggerStructureDamage(mIDTimberCamp, 1, 90);
                        //msgSound2 = "/../../Voice/Figures/timber%20harvester_05.mp3";
                        DisplayRiot(game, "Druibk_Riot");
                        iCommodus++;
                        tCommodus = nTime + 240;
                    }
                    else
                        tCommodus += 20;
                    break;

                case 6:
                    DisplayMessage(game, "Commodus_Priest");
                    iCommodus++;
                    tCommodus = nTime + 80;
                    break;

                case 7:
                    game.GetActiveBuildings(mIDJupiterTemple, out nB1);
                    game.GetActiveBuildings(mIDMarsTemple, out nB2);
                    game.GetActiveBuildings(mIDBacchusTemple, out nB3);
                    if ((nB1 > 0) && (nB2 > 0) && (nB3 > 0))
                    {
                        game.TriggerFireDamage(mIDSheepFarm, 1, 35);
                        DisplayMessage(game, "Commodus_Sheep");
                        iCommodus++;
                        tCommodus = nTime + 240;
                    }
                    else
                        tCommodus += 20;
                    break;

                case 8:
                    DisplayMessage(game, "Commodus_Arena");
                    game.UnlockUIControl(mUIIDArena, Toolset.MainGameFormID);
                    iCommodus++;
                    tCommodus = nTime + 120;
                    break;

                case 9:
                    game.GetActiveBuildings(mIDArena, out num);
                    if (num > 0)
                    {
                        DisplayMessage(game, "Arena_Fire");
                        game.TriggerFireDamage(mIDArena, 1, 35);
                        iCommodus++;
                        tCommodus = nTime + 160;
                    }
                    else
                        tCommodus += 40;
                    break;

                case 10:
                    DisplayMessage(game, "Commodus_Cathius");
                    game.UnlockUIControl(mUIIDExoticMarket, Toolset.MainGameFormID);
                    iCommodus++;
                    tCommodus = nTime + 120;
                    break;

                case 11:
                    game.GetActiveBuildings(mIDOdeum, out nB1);
                    game.GetTotalBuildings(mIDExoticMarket, out nB2);
                    if ((nB1 > 0) && (nB2 > 0))
                    {
                        DisplayRiot(game, "Cathius");
                        LogMessage(game, "Limerick");
                        game.TriggerStructureDamage(mIDOdeum, 1, 95);
                        iCommodus++;
                        tCommodus = nTime + 240;
                    }
                    else
                        tCommodus = nTime + 20;
                    break;

                case 12:
                    DisplayMessage(game, "Commodus_Envoy");
                    iCommodus++;
                    tCommodus = nTime + 80;
                    break;

                case 13:
                    DisplayMessage(game, "Commodus_Goblets");
                    iCommodus++;
                    tCommodus = nTime + 40;
                    break;

                case 14:
                    game.GetResource(mIDIron, out nB1);
                    game.GetResource(mIDTimber, out nB2);
                    if ((nB1 > 5) && (nB2 > 5))
                    {
                        DisplayMessage(game, "Goblets_Ready");
                        iCommodus++;
                        tCommodus = nTime + 120;
                    }
                    break;

                case 15:
                    DisplayMessage(game, "Belgarum_Open");
                    game.OpenTradeRoute(kBelgarum);
                    tState[kBelgarum] = nTime;
                    nRoutes++;
                    iCommodus++;
                    tCommodus = 9999999;
                    break;

                case 16:
                    break;
            }
        }
        
        //////////////////////////////////////////////
        // Easter Egg code goes here!
        void CheckEasterEggs(IGameQueryInterface game)
        {
            uint num, nB1, nB2 = 0;
            bool bOpen = false;
            if (!bMango)
            {
                game.GetActiveBuildings(mIDEstate2, out nB1);
                if (nB1 > 0)
                {
                    game.GetIsTradeRouteOpen(kAramannopolis, out bOpen);
                    if (bOpen)
                    {
                        DisplayMessage(game, "Bloodsuckers");
                        game.UnlockUIControl(mUIIDHospital, Toolset.MainGameFormID);
                        bMango = true;
                        tMango = nTime + 240;
                    }
                    else if (!bIgorus)
                    {
                        bIgorus = true;
                        DisplayMessage(game, "Mango_Daquiri");
                        game.UnlockUIControl(-520227242, Toolset.EmpireLevelFormID);
                    }
                }
            }
            else if (nTime > tMango)
            {
                if (!bBelaches)
                {
                    DisplayMessage(game, "Belaches_Sighted");
                    game.OpenTradeRoute(kBelgarum);
                    bBelaches = true;
                    tMango = nTime + 40;
                }
                else
                {
                    DisplayMessage(game, "Beached_Belache");
                    tMango = 999999;
                }
            }
        }

        /////////////////////////////////////////////
        // Simulated raids for vital goods
        void CheckForRaids(IGameQueryInterface game)
        {
            uint iPlace = 0;
            uint tFavor = oldFavor;
            if (nTime < 3000)
            {
                if (nFavor > oldFavor)
                {
                    if (iState[kRatae] == 0)
                    {
                        tState[kRatae] = nTime + 38;
                        iState[kRatae] = 1;
                    }
                    else
                    {
                        tState[kViruconium] = nTime + 38;
                        iState[kViruconium] = 1;
                    }
                }
                else if ((iState[kRatae] == 1) && (nTime > tState[kRatae]))
                    iPlace = kRatae;
                else if ((iState[kViruconium] == 1) && (nTime > tState[kViruconium]))
                    iPlace = kViruconium;
            }
            else 
            {
                if ((iState[kRatae] == 0) || (iState[kViruconium] == 0))
                {
                    if (nCityFunds < 0)
                        tFavor += 2;
                    else
                        tFavor += 3;
                }
                
                if (nFavor > tFavor)
                {
                    if (iState[kIcenorum] == 0)
                    {
                        tState[kIcenorum] = nTime + 38;
                        iState[kIcenorum] = 1;
                    }
                    else if (iState[kRatae] == 0)
                    {
                        tState[kRatae] = nTime + 38;
                        iState[kRatae] = 1;
                    }
                    else if (iState[kViruconium] == 0)
                    {
                        tState[kViruconium] = nTime + 38;
                        iState[kViruconium] = 1;
                    }
                }
                else if (nFavor > oldFavor)
                {
                    if (iState[kRatae] == 0)
                    {
                        tState[kRatae] = nTime + 38;
                        iState[kRatae] = 1;
                    }
                    else if (iState[kViruconium] == 0)
                    {
                        tState[kViruconium] = nTime + 38;
                        iState[kViruconium] = 1;
                    }
                    else if (iState[kIcenorum] == 0)
                    {
                        tState[kIcenorum] = nTime + 38;
                        iState[kIcenorum] = 1;
                    }
                }
                else if ((iState[kIcenorum] == 1) && (nTime > tState[kIcenorum]))
                    iPlace = kIcenorum;
                else if ((iState[kRatae] == 1) && (nTime > tState[kRatae]))
                    iPlace = kRatae;
                else if ((iState[kViruconium] == 1) && (nTime > tState[kViruconium]))
                    iPlace = kViruconium;
            }
            
            if (iPlace > 0)
            {
                game.FlashUIControl(mUIIDStorage, Toolset.MainGameFormID, 1000);
                game.OpenTradeRoute(iPlace);
                iState[iPlace] = 2;
                nRoutes++;
                if (!bJulius)
                    GiveAcclamation(game, sPlace[iPlace]);
                else
                    GiveAcclamation(game, sPlace[iPlace] + "_J");
            }
            else if (!bSweep && (nTime > 3190))
                SweepUpRaids(game);
            oldFavor = nFavor;
        }

        //////////////////////////////////////////////
        // Message on first batch of sweeping up raids
        void SweepUpRaids(IGameQueryInterface game)
        {
            uint iStates = iState[kRatae] + iState[kViruconium];
            if (iStates == 4)
                DisplayMessage(game, "SP_Intercept");
            else if (iStates == 0)
                DisplayMessage(game, "RataeViruconium2");
            else if (iState[kRatae] == 0)
                DisplayMessage(game, "Ratae2");
            else
                DisplayMessage(game, "Viruconium2");
            bSweep = true;
        }

        /////////////////////////////////////////////
        // Check that we have a palace for Boudicca
        void CheckForPalace(IGameQueryInterface game)
        {
            if (nPalace(game) == 0)
            {
                game.LockUIControl(mUIIDFortArcher, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDFortCavalry, Toolset.MainGameFormID);
                if ((iPalace == 0) && (nTime > 120))
                {
                    DisplayMessage(game, "Palace_Needed");
                    iPalace = 1;
                }
                else if (iPalace == 2)
                    iPalace = 1;
            }
            else
            {
                iPalace = 2;
                game.UnlockUIControl(mUIIDFortArcher, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDFortCavalry, Toolset.MainGameFormID);
            }
        }

        ///////////////////////////////////////////////////////
        // Enforce limit on number of villas - no more than one
        void LimitVillas(IGameQueryInterface game)
        {
            uint num, maxPat, nKablooey = 0;
            Int32 mID;

            if (nTime < 640) CheckForPalace(game);           
                
            if (nTime > tVillaCheck)
            {
                tVillaCheck = nTime + 40;
                maxPat = 1;
                for (int i = 1; i < 9; i++)
                {
                    mID = IDMaker.FromString(sPatricians[i]);
                    game.GetTotalBuildings(mID, out num);
                    if (num > maxPat)
                    {
                        num = num - maxPat;
                        maxPat = 0;
                        game.TriggerFireDamage(mID, (int)num, 99);
                        nKablooey += num;
                    }
                }
                if (nKablooey == 1)
                    DisplayRiot(game, "Villa_Kablooey");
                else if (nKablooey > 1)
                    DisplayRiot(game, "Villas_Kablooey");
            }
            else if (nTime > tLuxury)
                LimitLuxury(game);
        }
        
        ///////////////////////////////////////////////////
        // Check for False Defeat condition and switch over
        void SwitchToRoman(IGameQueryInterface game)
        {
            if (nFavor < 15)
            {
                if (!bSeutonius)
                {
                    bSeutonius = true;
                    DisplayMessage(game, "Seutonius_Here");
                    SeutoniusInvasion(game);
                }
            }
            else if ((iBurn == 0) && ((nCulture < 20) || (nProsperity < 10)))
            {
                game.ScriptDone = true;
                game.OpenTradeRoute(kDefeat);
            }
            else
            {
                if (iBurn < 17)
                {
                    if (iBurn == 0)
                    {
                        // Signal false defeat and the switch
                        msgTitle = "False_Defeat_Title";
                        msgText = "False_Defeat_Message";
                        game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                            (uint)MessageDisplay.kMessageDisplayTutorial, ref msgTitle, ref msgText, ref msgSound);
                    }
                    CityBurns(game);
                }
                else if (!bNewRoutes)
                {
                    DisplayMessage(game, "New_Routes");
                    game.OpenTradeRoute(kBelgica);
                    game.OpenTradeRoute(kLugdunensis);
                    bNewRoutes = true;
                }
                else if (!bJulius)
                {
                    bJulius = true;
                    game.UnlockUIControl(mUIIDShipBridge, Toolset.MainGameFormID);  
                    game.UnlockUIControl(mUIIDTheater, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDActor, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDLibrary, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDColiseum, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDBasilica, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDForum, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDFortLight, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDFortHeavy, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDObelisk, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDSalary, Toolset.AdvisorsFormID);
                    nPlebWages = 20;
                    nEquiteWages = 24;
                    game.SetRomeStandardRate(true, nPlebWages);
                    game.SetRomeStandardRate(false, nEquiteWages);
                    DisplayMessage(game, "Standard_Wages");
                    rFavor = Math.Max(50, (nFavor + 10));
                    tGrace = nTime + 480;
                    bGraceWarn = true;
                    tGraceWarn = nTime + 5;
                    bGrace = false;
                }
                else if (nTime > tGrace)
                {
                    bGrace = true;
                    if (nFavor < rFavor)
                    {
                        DisplayMessage(game, "Seutonius_Back");
                        SeutoniusInvasion(game);
                    }
                    else
                        DisplayMessage(game, "Favor");
                }
                else if (nTime > tGraceWarn)
                {
                    if (!bGraceWarn)
                    {
                        if (nFavor < rFavor)
                        {
                            DisplayMessage(game, "Patience_Thin");
                            bGraceWarn = true;
                            tGraceWarn = 999999;
                        }
                    }
                    else
                    {
                        tGraceWarn = tGrace - 80;
                        bGraceWarn = false;
                        if (rFavor == 50)
                        {
                            DisplayWarning(game, "Need_50_Favor_Text");
                            LogMessage(game, "Need_50_Favor");
                        }
                        else
                        {
                            DisplayWarning(game, "Add_10_Favor_Text");
                            LogMessage(game, "Add_10_Favor");
                        }
                    }
                }
            }
        }

        //////////////////////////////////////////////////////////
        // 1st invasion is triggered (1st year) September 1st year
        void SeutoniusInvasion(IGameQueryInterface game)
        {
            String invasion = "invSeutonius";
            InvasionSetup mInvasion;
            mInvasion = new InvasionSetup(invasion, "Roman", eInvasionType.kInvasion, 0, 4, 0);
            mInvasion.AddCohort("ENEMY_ROMAN", 20, 9, 9);
            mInvasion.AddCohort("ENEMY_ROMAN_CATAPULT", 5, 9, 9);
            nInvasion++;
            mInvasion.CreateInvasion(game, nInvasion, 0);
            game.StartInvasion(ref invasion);
        }

        //////////////////////////////////////////////////////////
        // Run through invasions from natives & Romans
        void DoInvasionSequence(IGameQueryInterface game)
        {
            String invasion;
            String orders = sCohortOrders.kRetreat;
            Int32[] iCohorts;
            InvasionSetup mInvasion;
                    
            switch (iInvasions)
            {
                case 1:
                    DisplayMessage(game, "Roman_Forts");
                    iInvasions++;
                    tInvasions = 560;
                    break;

                case 2:
                    DisplayMessage(game, "Rome_Warning_S");
                    iInvasions++;
                    tInvasions = 640;
                    break;

                case 3:
                    invasion = "Rome1";
                    mInvasion = new InvasionSetup(invasion, "Roman", eInvasionType.kInvasion, 0, 4, 0);
                    mInvasion.AddCohort("ENEMY_ROMAN", 1, 9, 4);
                    mInvasion.CreateInvasion(game, 0, 0);
                    game.StartInvasion(ref invasion);
                    DisplayMessage(game, "Rome_Invasion");
                    iPalace = 2;
                    iInvasions++;
                    tInvasions = 660;
                    break;

                case 4:
                    // this stops the invaders attacking - scouting force
                    invasion = "Rome1";
                    game.StopInvasion(ref invasion, true);
                    game.GetInvaderCohorts(ref invasion, out iCohorts);
                    foreach (Int32 cohortID in iCohorts)
                        game.SetCohortOrders(cohortID, ref orders);
                    iInvasions++;
                    tInvasions = 800;
                    break;

                case 5:
                    DisplayMessage(game, "Scouting");
                    iInvasions++;
                    tInvasions = 1480;
                    break;

                case 6:
                    DisplayMessage(game, "Raid_Warn");
                    iInvasions++;
                    tInvasions = 1560;
                    break;

                case 7:
                    invasion = "raid57AD";
                    mInvasion = new InvasionSetup(invasion, "Gaul", eInvasionType.kRaid, 750, 4, 0);
                    mInvasion.AddCohort("ENEMY_GAUL_LT", 1, 7, 7);
                    mInvasion.CreateInvasion(game, 1, 0);
                    nInvasion++;
                    game.StartInvasion(ref invasion);
                    DisplayMessage(game, "Raid_0");
                    iInvasions++;
                    tInvasions = 2120;
                    break;

                case 8:
                    DisplayMessage(game, "Rome_PC1");
                    iInvasions++;
                    tInvasions = 2280;
                    break;

                case 9:
                    DisplayMessage(game, "Rome_Warning_R");
                    iInvasions++;
                    tInvasions = 2360;
                    break;

                case 10:
                    invasion = "Rome2";
                    mInvasion = new InvasionSetup(invasion, "Roman", eInvasionType.kInvasion, 0, 4, 0);
                    mInvasion.AddCohort("ENEMY_ROMAN", 1, 5, 5);
                    mInvasion.CreateInvasion(game, 2, 0);
                    nInvasion = 2;
                    game.StartInvasion(ref invasion);
                    DisplayMessage(game, "Rome_Invasion");
                    iInvasions++;
                    tInvasions = 2920;
                    break;

                case 11:
                    DisplayMessage(game, "Rome_PC2");
                    iInvasions++;
                    tInvasions = 3080;
                    break;

                case 12:
                    DisplayMessage(game, "Rome_Warning_2");
                    iInvasions++;
                    tInvasions = 3160;
                    break;

                case 13:
                    invasion = "Rome3";
                    mInvasion = new InvasionSetup(invasion, "Roman", eInvasionType.kInvasion, 0, 4, 0);
                    mInvasion.AddCohort("ENEMY_ROMAN", 1, 6, 6);
                    mInvasion.AddCohort("ENEMY_ROMAN_CATAPULT", 1, 6, 6);
                    nInvasion = 3;
                    mInvasion.CreateInvasion(game, 3, 0);
                    game.StartInvasion(ref invasion);
                    DisplayMessage(game, "Rome_Invasion");
                    iInvasions++;
                    tInvasions = 3480;
                    break;

                case 14:
                    DisplayMessage(game, "Isca_News");
                    iInvasions++;
                    tInvasions = 3720;
                    break;

                case 15:
                    DisplayMessage(game, "Rome_SP");
                    iInvasions++;
                    tInvasions = 3880;
                    break;

                case 16:
                    DisplayMessage(game, "Rome_Warning_3");
                    iInvasions++;
                    tInvasions = 3960;
                    break;

                case 17:
                    invasion = "Rome4";
                    mInvasion = new InvasionSetup(invasion, "Roman", eInvasionType.kInvasion, 0, 4, 0);
                    mInvasion.AddCohort("ENEMY_ROMAN", 2, 9, 9);
                    mInvasion.AddCohort("ENEMY_ROMAN_SOLO_RAZE", 2, 9, 9);
                    mInvasion.AddCohort("ENEMY_ROMAN_CATAPULT", 1, 9, 9);
                    nInvasion = 4;
                    mInvasion.CreateInvasion(game, 4, 0);
                    game.StartInvasion(ref invasion);
                    DisplayMessage(game, "Rome_Invasion");
                    iInvasions++;
                    tInvasions = 4560;
                    break;

                case 18:
                    DisplayMessage(game, "Romans_Coming");
                    iInvasions++;
                    tInvasions = 4680;
                    break;

                case 19:
                    DisplayMessage(game, "Rome_Warning_3");
                    iInvasions++;
                    tInvasions = 4760;
                    break;

                case 20:
                    invasion = "Rome5";
                    mInvasion = new InvasionSetup(invasion, "Roman", eInvasionType.kInvasion, 0, 4, 0);
                    nInvasion = 5;
                    mInvasion.AddCohort("ENEMY_ROMAN", 3, 4, 4);
                    mInvasion.AddCohort("ENEMY_ROMAN_SOLO_RAZE", 3, 4, 4);
                    mInvasion.AddCohort("ENEMY_ROMAN_CATAPULT", 1, 4, 4);
                    mInvasion.CreateInvasion(game, 4, 0);
                    game.StartInvasion(ref invasion);
                    DisplayMessage(game, "Rome_Invasion");
                    iInvasions++;
                    tInvasions = 6000;
                    break;

                case 21:
                    DisplayMessage(game, "Tribe_Warn");
                    nInvasion++;
                    iInvasions++;
                    tInvasions = nTime + 80;
                    break;

                case 22:
                    invasion = "TribeAttack" + nInvasion.ToString();
                    mInvasion = new InvasionSetup(invasion, "Gaul", eInvasionType.kRaid, 2000, 4, 0);
                    mInvasion.AddCohort("ENEMY_GAUL_LT", 5, 5, 5);
                    mInvasion.AddCohort("ENEMY_GAUL_AUX", 3, 7, 7);
                    mInvasion.CreateInvasion(game, nInvasion, 0);
                    game.StartInvasion(ref invasion);
                    DisplayMessage(game, "Tribe_Attack");
                    iInvasions++;
                    tInvasions = nTime + 120;
                    break;

                case 23:
                    if (!game.AnyActiveInvasions)
                    {
                        iInvasions = 21;
                        tInvasions = nTime + 320;
                    }
                    else
                        tInvasions = nTime + 10;
                    break;
            }
        }

        //////////////////////////////////////////////
        // Initialise Pleb & Equite wage expectations 
        void SetInitialWages(IGameQueryInterface game)
        {
            nPlebWages = 8;
            nEquiteWages = 12;
            game.SetRomeStandardRate(true, nPlebWages);
            game.SetRomeStandardRate(false, nEquiteWages);
            game.UnlockUIControl(mUIIDTaxman, Toolset.MainGameFormID);
            DisplayMessage(game, "Start_Paying_Wages");
        }

        ////////////////////////////////////////////////////////////////////////////
        // Adjust Pleb & Equite wage expectations each year treasury exceeds 10000dn
        void CheckWageExpectations(IGameQueryInterface game)
        {
            if (nCityFunds >= nWageTrigger)
            {
                nPlebWages += 2;
                nEquiteWages += 3;
                game.SetRomeStandardRate(true, nPlebWages);
                game.SetRomeStandardRate(false, nEquiteWages);
                // now advise player of raised expectations
                DisplayMessage(game, "Wage_Change");
            }
            tWageCheck = nTime + 960;           // next check in 12 months time
        }

        //////////////////////////////////////////
        // Check on allowed tax offices
        void TaxCheck(IGameQueryInterface game)
        {
            uint num, nMax;
            if (iTax == 0)
            {
                DisplayMessage(game, "Tax_Office");
                tTaxCheck = 200;
                iTax++;
            }
            else if (iTax == 1)
            {
                game.GetResource(mIDClay, out num);
                if (num > 5)
                {
                    iTax++;
                    DisplayMessage(game, "Taxation");
                    game.UnlockUIControl(mUIIDTaxman, Toolset.MainGameFormID);
                }
                tTaxCheck += 20;
            }
            else
            {
                game.GetActiveBuildings(mIDTaxOffice, out num);
                if (bJulius)
                    nMax = 2;
                else
                    nMax = 1;

                if (num > nMax)
                {
                    num--;
                    DisplayRiot(game, "Tax_Riot");
                    game.TriggerFireDamage(mIDTaxOffice, (int)num, 99);
                    tTaxCheck = nTime + 20;
                }
                tTaxCheck += 20;
            }
        }

        ////////////////////////////////////////////////
        // Check for an excessive amount of luxury goods
        // first to go will be a lux market
        // after that target factories (2) wine, furniture, utensils
        // after that target a random warehouse
        // then back to lux market
        void LimitLuxury(IGameQueryInterface game)
        {
            uint nB1, nR1, nR2, nR3, nLux;
            game.GetResource(mIDWine, out nR1);
            game.GetResource(mIDFurniture, out nR2);
            game.GetResource(mIDUtensils, out nR3);
            nLux = nR1 + nR2 + nR3;
            if (nLux > maxLuxury)
            {
                if (iLuxury == 0)
                {
                    game.GetTotalBuildings(mIDLuxuryMarket, out nB1);
                    if (nB1 > 0)
                    {
                        DisplayMessage(game, "Market_Raid");
                        game.TriggerStructureDamage(mIDLuxuryMarket, 1, 100);
                    }
                    else
                        iLuxury++;
                }
                if (iLuxury == 1)
                {
                    game.GetTotalBuildings(mIDWineFactory, out nB1);
                    if (nB1 > 0)
                    {
                        DisplayMessage(game, "Wine_Raid");
                        game.TriggerStructureDamage(mIDWineFactory, 2, 100);
                    }
                    else
                        iLuxury++;
                }
                if (iLuxury == 2)
                {
                    game.GetTotalBuildings(mIDFurnitureFactory, out nB1);
                    if (nB1 > 0)
                    {
                        DisplayMessage(game, "Furniture_Raid");
                        game.TriggerStructureDamage(mIDFurnitureFactory, 2, 100);
                    }
                    else
                        iLuxury++;
                }
                if (iLuxury == 3)
                {
                    game.GetTotalBuildings(mIDUtensilsFactory, out nB1);
                    if (nB1 > 0)
                    {
                        DisplayMessage(game, "Utensils_Raid");
                        game.TriggerStructureDamage(mIDUtensilsFactory, 2, 100);
                    }
                    else
                        iLuxury++;
                }
                if (iLuxury == 4)
                {
                    game.GetTotalBuildings(mIDWarehouse, out nB1);
                    if (nB1 > 0)
                    {
                        DisplayMessage(game, "Warehouse_Raid");
                        game.TriggerStructureDamage(mIDWarehouse, 2, 100);
                    }
                    else
                        iLuxury++;
                }
                iLuxury++;
                if (iLuxury > 4) iLuxury = 0;
            }
            tLuxury = nTime + 30;
        }

        ////////////////////////////////////////////////////////////////////////////
        // Beauty rating is calculated every week
        // Current rating increases or decreases by 1 every week towards this value
        // Display two weeks - aim for middle and end of each month
        void ShowBeautyRating(IGameQueryInterface game)
        {
            GetBeautyRating(game);
            if (uBeauty > nBeauty)
                nBeauty++;
            else if (uBeauty < nBeauty)
                nBeauty--;

            if (bBeauty)
            {
                String msgWarn = "Beauty_Rating_" + nBeauty.ToString();
                String msgNoSound = "";
                game.SendWarningMessage(ref msgWarn, ref msgNoSound);
                bBeauty = false;
            }
            else
                bBeauty = true;
        }

        ////////////////////////////////////////////////////////////////////////////////////
        // Controls Beauty Rating calculation - undesirable factor vs total desirable factor
        void GetBeautyRating(IGameQueryInterface game)
        {
            CountHomes(game);
            AddUndesirables(game);
            uUndes = Math.Max(uUndes, 100);
            uBeauty = 0;
            AddStatueBR(game);
            AddTHBScore(game);
            uDeco = uBeauty;
            AddGovBR(game);
            AddEntBR(game);
            AddRelBR(game);
            AddPatBR(game);
            AddOtherBR(game);
            if (uBeauty > 100) uBeauty = 100;
            tBeautyCheck += 20;
        }

        //////////////////////////////////////////////////////////////////////////////////
        // Counts the number of homes for 'coverage' purposes in calculating Beauty Rating
        void CountHomes(IGameQueryInterface game)
        {
            Int32 mID;
            uint num, nHomes = 0;
            string[] sHomes = {"C4b Plebian home 01", "C4b Plebian home 02", "C4b Plebian home 03",
                              "C4b Equites Housing 01", "C4b Equites Housing 02", "C4b Equites Housing 03"};

            for (int i = 0; i < 6; i++)
            {
                mID = IDMaker.FromString(sHomes[i]);
                game.GetTotalBuildings(mID, out num);
                nHomes += num;
            }
            for (int i = 0; i < 9; i++)
            {
                mID = IDMaker.FromString(sPatricians[i]);
                game.GetTotalBuildings(mID, out num);
                nHomes += num;
            }
            uUndes = nHomes * 2;
        }

        ///////////////////////////////////////////////////////////////////////////////
        // Calculates the negative effect on Beauty rating from 'undesirable' buildings
        void AddUndesirables(IGameQueryInterface game)
        {
            AddUndesirable(game, mIDCattleFarm, 1);
            AddUndesirable(game, mIDClayCamp, 1);
            AddUndesirable(game, mIDIronMine, 1);
            AddUndesirable(game, mIDTimberCamp, 1);
            AddUndesirable(game, mIDGranary, 1);
            AddUndesirable(game, mIDWarehouse, 1);
            AddUndesirable(game, mIDDepot, 1);
            AddUndesirable(game, mIDPort, 1);
            AddUndesirable(game, mIDPotteryFactory, 1);
            AddUndesirable(game, mIDFurnitureFactory, 1);
            AddUndesirable(game, mIDUtensilsFactory, 2);
            AddUndesirable(game, mIDArmorFactory, 2);
            AddUndesirable(game, mIDWeaponsFactory, 2);
            AddUndesirable(game, mIDArmory, 2);
            AddUndesirable(game, mIDMessHall, 2);
            AddUndesirable(game, mIDFortCavalry, 4);
            AddUndesirable(game, mIDFortHeavy, 4);
            AddUndesirable(game, mIDFortLight, 4);
            AddUndesirable(game, mIDFortArchers, 3);
            AddUndesirable(game, mIDDrillYard, 4);
        }

        /////////////////////////////////////////////////////////////////////
        // Adds the "undesirable" contribution for the specified building
        void AddUndesirable(IGameQueryInterface game, Int32 mID, uint iFactor)
        {
            uint num = 0;
            game.GetTotalBuildings(mID, out num);
            uUndes += iFactor * num;
        }

        ////////////////////////////////////////////////////////////
        // Beauty Rating from Government buildings
        void AddGovBR(IGameQueryInterface game)
        {
            uint num;
            uGovBR = nPalace(game);
            game.GetActiveBuildings(mIDBasilica, out num);
            if (num > 0) uGovBR += 3;
            uDes = uUndes / 2;
            AddWeightedBuild(game, mIDForum, 240, 3);
            uGovBR += uDes / uUndes;
            uBeauty += uGovBR;
        }

        ////////////////////////////////////////////////////////////
        // Beauty Rating from Temples & Shrines
        void AddRelBR(IGameQueryInterface game)
        {
            uDes = uUndes / 2;
            AddWeightedBuild(game, mIDJupiterTemple, 200, 2);
            AddWeightedBuild(game, mIDMarsTemple, 200, 2);
            AddWeightedBuild(game, mIDCeresTemple, 200, 2);
            AddWeightedBuild(game, mIDBacchusTemple, 200, 2);
            AddWeightedBuild(game, mIDMercuryTemple, 200, 2);
            AddFullBuild(game, mIDJupiterShrine, 40, 1);
            AddFullBuild(game, mIDMarsShrine, 40, 1);
            AddFullBuild(game, mIDMercuryShrine, 40, 1);
            uRelBR = Math.Min((uDes / uUndes), 10);
            uBeauty += uRelBR;
        }

        //////////////////////////////////////////////
        // Beauty Rating from Entertainment buildings
        void AddEntBR(IGameQueryInterface game)
        {
            uint uMax, num;
            uDes = uUndes / 2;
            AddFullBuild(game, mIDOdeum, 160, 3);
            AddFullBuild(game, mIDActor, 160, 2);
            num = nDesVenue(game, mIDTheater, 0);
            uDes += Math.Min((num * 320), (uUndes * 4));
            uMax = uUndes * 3;
            num = nDesVenue(game, mIDArena, 1);
            uDes += Math.Min((num * 200), uMax);
            num = nDesVenue(game, mIDColiseum, 2);
            if (num > 0) uDes += uMax;
            num = nDesVenue(game, mIDCircus, 3);
            if (num > 0) uDes += uMax;

            uEntBR = Math.Min((uDes / uUndes), 16);
            uBeauty += uEntBR;
        }

        ////////////////////////////////////////
        // Beauty Rating from Patrician villas
        void AddPatBR(IGameQueryInterface game)
        {
            uint num;
            Int32 mID;
            uDes = uUndes / 2;
            for (int i = 0; i < 9; i++)
            {
                mID = IDMaker.FromString(sPatricians[i]);
                game.GetTotalBuildings(mID, out num);
                uDes += (uint)i * num * 20;
            }
            uPatBR = Math.Min((uDes / uUndes), 10);
            uBeauty += uPatBR;
        }

        ////////////////////////////////////////////////
        // Beauty Rating from other desirable buildings
        void AddOtherBR(IGameQueryInterface game)
        {
            uDes = uUndes / 2;
            AddFullBuild(game, mIDFountain, 160, 2);
            AddFullBuild(game, mIDLibrary, 320, 3);
            AddFullBuild(game, mIDBathhouse, 160, 3);
            AddWeightedBuild(game, mIDHospital, 120, 2);
            AddFullBuild(game, mIDExoticMarket, 160, 1);
            AddFullBuild(game, mIDLuxuryMarket, 80, 1);
            uOtherBR = Math.Min((uDes / uUndes), 8);
            uBeauty += uOtherBR;
        }

        /////////////////////////////////////////////////////////////////
        // Venues are counted as inactive even if waiting for actors etc.
        // Allow venue to be inactive for 4 weeks before losing beauty
        uint nDesVenue(IGameQueryInterface game, Int32 mID, int iVenue)
        {
            uint num1, num2 = 0;
            game.GetActiveBuildings(mID, out num1);
            game.GetInactiveBuildings(mID, out num2);
            if ((num2 > 0) && (nTime < 7620))
            {
                if (bEmptyVenue[iVenue])
                    num2 = 0;
                else
                    bEmptyVenue[iVenue] = true;
            }
            else
                bEmptyVenue[iVenue] = false;

            return (num1 + num2);
        }

        ///////////////////////////////////////////////////////////////////
        // Add to 'desirable' score capped at uMax 
        void AddFullBuild(IGameQueryInterface game, Int32 mID, uint iFactor, uint uMax)
        {
            uint num;
            game.GetActiveBuildings(mID, out num);
            uDes += Math.Min((iFactor * num), (uMax * uUndes));
        }

        ////////////////////////////////////////////////////////////////////////
        // Beauty Rating where subsequent builds count less than the first
        void AddWeightedBuild(IGameQueryInterface game, Int32 mID, uint iFactor, uint uMax)
        {
            uint num;
            game.GetActiveBuildings(mID, out num);
            if (num > 0) num++;
            uDes += Math.Min((iFactor * num), (uMax * uUndes));
        }

        /////////////////////////////////////////////
        // Beauty Rating from Statues
        void AddStatueBR(IGameQueryInterface game)
        {
            uint num, numB;
            // small statues
            game.GetTotalBuildings(mIDStatue1, out num);
            numB = Math.Min((num / 8), 3);
            game.GetTotalBuildings(mIDStatue2, out num);
            numB += Math.Min((num / 8), 3);
            uSmallST = Math.Min(numB, 4);
            uBeauty += uSmallST;
            // medium statues + obelisk
            game.GetTotalBuildings(mIDStatue3, out num);
            numB = Math.Min((num / 4), 3);
            game.GetTotalBuildings(mIDStatue4, out num);
            numB += Math.Min((num / 4), 3);
            game.GetTotalBuildings(mIDObelisk, out num);
            numB += Math.Min(((num * 3 + 1) / 5), 6);
            uMediumST = Math.Min(numB, 10);
            uBeauty += uMediumST;
            // large statues
            game.GetTotalBuildings(mIDStatue5, out num);
            numB = Math.Min((num / 2), 5);
            game.GetTotalBuildings(mIDStatue6, out num);
            numB += Math.Min(((num * 5 + 1) / 6), 5);
            uLargeST = Math.Min(numB, 8);
            uBeauty += uLargeST;
        }

        ////////////////////////////////////////////
        // Beauty Rating from Trees, Hedges & Bushes
        void AddTHBScore(IGameQueryInterface game)
        {
            uint num1, num2, uMax;
            uDes = 0;
            AddFullBuild(game, mIDGarden, 40, 5);
            uGarden = uDes / uUndes;
            uDes = 0;
            AddFullBuild(game, mIDBushSmall, 20, 3);
            AddFullBuild(game, mIDBushLarge, 40, 5);
            uBush = uDes / uUndes;
            uDes = 0;
            AddFullBuild(game, mIDTreeSmall, 20, 3);
            AddFullBuild(game, mIDTreeMedium, 40, 5);
            uTree1 = uDes / uUndes;
            uDes = 0;
            AddFullBuild(game, mIDTreeLarge, 80, 7);
            uTree2 = uDes / uUndes;
            uMax = uUndes * 3;
            uDes = uUndes / 2;
            game.GetTotalBuildings(mIDHedgeLarge, out num1);
            game.GetTotalBuildings(mIDHedgeRowLarge, out num2);
            uDes += Math.Min(((num1 + num2) * 10), uMax);
            game.GetTotalBuildings(mIDHedgeSmall, out num1);
            game.GetTotalBuildings(mIDHedgeRowSmall, out num2);
            uDes += Math.Min(((num1 + num2) * 5), uMax);

            uTHB = Math.Min(((uDes / uUndes) + uGarden + uBush + uTree1 + uTree2), 28);
            uBeauty += uTHB;
        }

        /////////////////////////////////////////////
        // Send message with applause to player
        void RouteAcclamation(IGameQueryInterface game)
        {
            msgTitle = "All_Routes_Title";
            msgText = "All_Routes_" + eWC1.ToString(); ;
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgApplause);
            bMessageSent = true;
        }

        /////////////////////////////////////////////
        // Send message with applause to player
        void GiveAcclamation(IGameQueryInterface game, String sMessage)
        {
            msgTitle = sMessage + "_Title";
            msgText = sMessage + "_Text";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgApplause);
            bMessageSent = true;
        }

        /////////////////////////////////////////////
        // Send basic message to player
        void DisplayMessage(IGameQueryInterface game, String sMessage)
        {
            msgTitle = sMessage + "_Title";
            msgText = sMessage + "_Text";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgSound);
            bMessageSent = true;
        }

        /////////////////////////////////////////////
        // Log message in message log only
        void LogMessage(IGameQueryInterface game, String sMessage)
        {
            msgTitle = sMessage + "_Title";
            msgText = sMessage + "_Text";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplayNone, ref msgTitle, ref msgText, ref msgSound);
            bMessageSent = true;
        }

        ///////////////////////////////////////////////
        // Send basic message (variable sound) to player
        void DisplayMessage2(IGameQueryInterface game, String sMessage)
        {
            msgTitle = sMessage + "_Title";
            msgText = sMessage + "_Text";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgSound2);
            bMessageSent = true;
        }

        /////////////////////////////////////////////
        // Send 'warning' to player
        void DisplayWarning(IGameQueryInterface game, String msgWarn)
        {
            game.SendWarningMessage(ref msgWarn, ref msgSound);
            bMessageSent = true;
        }

        //////////////////////////////////////////
        // Send 'riot warning' to player
        void DisplayRiot(IGameQueryInterface game, String sMessage)
        {
            msgTitle = sMessage + "_Title";
            msgText = sMessage + "_Text";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgRiot);
            bMessageSent = true;
        }

        //////////////////////////////////////////////////////////////////////////////////
        // Ally's Secret Easter Egg - no looking Paul & Steve on PAIN OF EXTREME DEATH!!!!
        void AllysSecret(IGameQueryInterface game)
        {
            uint nB1, nR1 = 0;
            if (bJulius)
            {
                if (nTime > tFMonthEnd)
                {
                    if (nTime > tFMonthStart) tFMonthStart += 960;
                    tFMonthEnd += 960;
                    game.CloseTradeRoute(15);
                }
                else if (nTime > tFMonthStart)
                {
                    game.GetResource(mIDIron, out nR1);
                    if (nR1 >= 16)
                    {
                        if (!bFrog)
                        {
                            DisplayMessage(game, "The_Frog");
                            LogMessage(game, "King_Frog");
                            bFrog = true;
                        }
                        game.OpenTradeRoute(15);
                        tFMonthStart += 960;
                    }
                }
                if (nTime > tSMonthEnd)
                {
                    if (nTime > tSMonthStart) tSMonthStart += 960;
                    tSMonthEnd += 960;
                }
                else if (nTime > tSMonthStart)
                {
                    game.GetActiveBuildings(mIDSheepFarm, out nB1);
                    if ((nB1 > 2) && !bSyebe)
                    {
                        bSyebe = true;
                        DisplayMessage(game, "Syeberia");
                        game.OpenTradeRoute(17);
                        tSMonthStart += 960;
                    }
                }
            } 
        }

        /////////////////////////////////////////////////
        // Returns > 0 if palace built (1, 3 or 5) else 0
        private uint nPalace(IGameQueryInterface game)
        {
            UInt32 num = 0;
            game.GetActiveBuildings(mIDPalace3, out num);
            if (num > 0) return 5;
            game.GetActiveBuildings(mIDPalace2, out num);
            if (num > 0) return 3;
            game.GetActiveBuildings(mIDPalace1, out num);
            if (num > 0) return 1;
            return 0;
        }

        ///////////////////////////////////////////////////////////////////////
        // check/set control panel buttons to guard against UnlockUIControl bug
        private void CheckBaseUI(IGameQueryInterface game)
        {
            if (iTax > 1) game.UnlockUIControl(mUIIDTaxman, Toolset.MainGameFormID);
            if (iCommodus > 2) game.UnlockUIControl(mUIIDSchool, Toolset.MainGameFormID);
            if (iCommodus > 8) game.UnlockUIControl(mUIIDArena, Toolset.MainGameFormID);
            if (iCommodus > 10) game.UnlockUIControl(mUIIDExoticMarket, Toolset.MainGameFormID);
            
            if (bPrefect)
            {
                game.UnlockUIControl(mUIIDPrefect, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDPlebHome, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDEquiteHome, Toolset.MainGameFormID);
            }
            if (iPalace == 2)
            {
                game.UnlockUIControl(mUIIDFortArcher, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDFortCavalry, Toolset.MainGameFormID);
            }
            if (bMango) game.UnlockUIControl(mUIIDHospital, Toolset.MainGameFormID);
            if (bJulius)
            {
                game.UnlockUIControl(mUIIDTheater, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDActor, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDLibrary, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDColiseum, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDBasilica, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDForum, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDShipBridge, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDFortLight, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDFortHeavy, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDObelisk, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDSalary, Toolset.AdvisorsFormID);
            }
            if (maxFavor > 75) game.UnlockUIControl(989726641, Toolset.AdvisorsFormID);
        }

        //////////////////////////////////////////////////////
        // return control panel buttons to their initial state
        private void ResetBaseUI(IGameQueryInterface game)
        {
            if (iTax < 2) game.LockUIControl(mUIIDTaxman, Toolset.MainGameFormID);
            if (iCommodus < 3) game.LockUIControl(mUIIDSchool, Toolset.MainGameFormID);
            if (iCommodus < 9) game.LockUIControl(mUIIDArena, Toolset.MainGameFormID);
            if (iCommodus < 11) game.LockUIControl(mUIIDExoticMarket, Toolset.MainGameFormID);
                
            if (!bPrefect)
            {
                game.LockUIControl(mUIIDPrefect, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDPlebHome, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDEquiteHome, Toolset.MainGameFormID);
            }
            if (iPalace < 2)
            {
                game.LockUIControl(mUIIDFortArcher, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDFortCavalry, Toolset.MainGameFormID);
            }
            if (!bIgorus) game.LockUIControl(-520227242, Toolset.EmpireLevelFormID);
            if (!bMango) game.LockUIControl(mUIIDHospital, Toolset.MainGameFormID);
            if (!bJulius)
            {
                game.LockUIControl(mUIIDTheater, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDActor, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDLibrary, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDColiseum, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDBasilica, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDForum, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDShipBridge, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDFortLight, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDFortHeavy, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDObelisk, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDSalary, Toolset.AdvisorsFormID);
            }
            if (maxFavor < 80) game.LockUIControl(989726641, Toolset.AdvisorsFormID);
        }

        ///////////////////////////////////////////
        // Send timer warning message
        void TimerMessage(IGameQueryInterface game)
        {
            DisplayWarning(game, (sTimeLeft[iMessage] + "_Months_Left"));
            iMessage++;
        }

        ///////////////////////////////////////////
        // Post victory scoring of points
        void ScorePoints(IGameQueryInterface game)
        {
            if (!game.ScriptDone)
            {
                game.GetResource(mIDWine, out eWine);
                game.GetResource(mIDFurniture, out eFurniture);
                game.GetResource(mIDUtensils, out eUtensils);
            }
            if (nFavor >= 80)
            {
                eProsperity = nProsperity;
                eCulture = nCulture;
                eFavor = nFavor;
                eSecurity = nSecurity;
                eWC2 = eProsperity + eCulture + eFavor + eSecurity + eWine + eFurniture + eUtensils;
                eWC3 = nCityFunds;
                bScored = true;
            }
        }

        void OnBeginScenario(IGameQueryInterface game)
        {
            //
            // INVASION SETUP
            //
            // mInvasions = new InvasionSetup[8];
            
            mMilitaryAI = new TMilitaryAI(game);
            //
            // MILITARY REQUEST SETUP
            //
            sMilitaryRequestInfo requestInfo = new sMilitaryRequestInfo();
            MilitaryRequest request;

            // First "raid" conquest
            requestInfo.mRequestID = 4;
            requestInfo.mReward = 5;
            requestInfo.mPenalty = 0;
            requestInfo.mStartWeek = 50;
            requestInfo.mVariance = 0;
            requestInfo.mRecursionWeek = 0;
            requestInfo.mDeadline = 88;
            requestInfo.mFirstWarning = 48;
            requestInfo.mSecondWarning = 86;
            requestInfo.mTravelTime = 2;
            requestInfo.mWorldSiteIndex = 5;  

            request = new MilitaryRequest();
            request.AddCohort("ENEMY_ROMAN_CATAPULT", 2);
            request.AddMilitaryRequest(requestInfo, game);

            // Second "raid" conquest
            requestInfo.mRequestID = 5;
            requestInfo.mReward = 5;
            requestInfo.mPenalty = 0;
            requestInfo.mStartWeek = 56;
            requestInfo.mVariance = 0;
            requestInfo.mRecursionWeek = 0;
            requestInfo.mDeadline = 84;
            requestInfo.mFirstWarning = 48;
            requestInfo.mSecondWarning = 82;
            requestInfo.mTravelTime = 2;
            requestInfo.mWorldSiteIndex = 7;

            request = new MilitaryRequest();
            request.AddCohort("ENEMY_ROMAN_SOLO_RAZE", 1);
            request.AddMilitaryRequest(requestInfo, game);

            // Third "raid" conquest
            requestInfo.mRequestID = 6;
            requestInfo.mReward = 5;
            requestInfo.mPenalty = 0;
            requestInfo.mStartWeek = 152;
            requestInfo.mVariance = 0;
            requestInfo.mRecursionWeek = 0;
            requestInfo.mDeadline = 100;
            requestInfo.mFirstWarning = 48;
            requestInfo.mSecondWarning = 98;
            requestInfo.mTravelTime = 2;
            requestInfo.mWorldSiteIndex = 1;

            request = new MilitaryRequest();
            request.AddCohort("ENEMY_ROMAN", 2);
            request.AddMilitaryRequest(requestInfo, game);

            // The showdown with the Romans
            requestInfo.mRequestID = 7;
            requestInfo.mReward = 0;
            requestInfo.mPenalty = 90;
            requestInfo.mStartWeek = 264;
            requestInfo.mVariance = 0;
            requestInfo.mRecursionWeek = 0;
            requestInfo.mDeadline = 3;
            requestInfo.mFirstWarning = 1;
            requestInfo.mSecondWarning = 2;
            requestInfo.mTravelTime = 1;
            requestInfo.mWorldSiteIndex = 15;

            request = new MilitaryRequest();
            request.AddCohort("ENEMY_ROMAN", 40);
            request.AddMilitaryRequest(requestInfo, game);

            // Repeating sweep-up request for Ratae/Viruconium
            requestInfo.mRequestID = 8;
            requestInfo.mReward = 3;
            requestInfo.mPenalty = 0;
            requestInfo.mStartWeek = 160;
            requestInfo.mVariance = 0;
            requestInfo.mRecursionWeek = 12;
            requestInfo.mDeadline = 240;
            requestInfo.mFirstWarning = 120;
            requestInfo.mSecondWarning = 232;
            requestInfo.mTravelTime = 2;
            requestInfo.mWorldSiteIndex = 7;

            request = new MilitaryRequest();
            request.AddCohort("ENEMY_GAUL_LT", 2);
            request.AddCohort("ENEMY_GAUL_AUX", 3);
            request.AddMilitaryRequest(requestInfo, game);

            // Repeating sweep-up request for Icenorum
            requestInfo.mRequestID = 9;
            requestInfo.mReward = 5;
            requestInfo.mPenalty = 0;
            requestInfo.mStartWeek = 280;
            requestInfo.mVariance = 0;
            requestInfo.mRecursionWeek = 12;
            requestInfo.mDeadline = 240;
            requestInfo.mFirstWarning = 120;
            requestInfo.mSecondWarning = 232;
            requestInfo.mTravelTime = 2;
            requestInfo.mWorldSiteIndex = 3;

            request = new MilitaryRequest();
            request.AddCohort("ENEMY_GAUL_LT", 3);
            request.AddCohort("ENEMY_GAUL_AUX", 3);
            request.AddMilitaryRequest(requestInfo, game);

            game.SetRomeStandardRate(true, 0);
            game.SetRomeStandardRate(false, 0);
                
            bInit = true;
        }

        // Initialization needed on scenario load (when loading save games)
        void OnScenarioLoad(IGameQueryInterface game)
        {
            bInit = true;
        }

        void OnInvasionArrival(IGameQueryInterface game)
        {
            Int32[] enemyCohorts;
            BasicCohortType cohortType;
            String cohortDbID;
            String invasion = game.RunInvasion;
            // This bit applies to the native invaders - Rome behaves like the Romans do
            String[] sTargets1 = { "C4b infra Granary", "C4b infra Warehouse" };
            String[] sTargets2 = { "C4b harvester Iron miners house", "C4b harvester Clay collector's house" };
            String orders = "RazeBuildings";
            String ordersRGV = "RazeGovernorVilla";
                
            bool bThis = true;
            game.GetInvaderCohorts(ref invasion, out enemyCohorts);
            if (nInvasion == 1)
            {
                orders = "CircleCity";
                tTargetSwitch = nTime + 60;
                foreach (Int32 cohortID in enemyCohorts)
                {
                    game.SetCohortOrders(cohortID, ref orders);
                }
            }
            else if (nInvasion == 2)
            {
                orders = "RazeMilitaryBuildings";
                tTargetSwitch = 999999;
                foreach (Int32 cohortID in enemyCohorts)
                {
                    game.SetCohortOrders(cohortID, ref orders);
                }
            }
            else if ((nInvasion == 3) || (nInvasion == 4))
            {
                foreach (Int32 cohortID in enemyCohorts)
                {
                    if (bThis)
                    {
                        game.SetCohortOrders(cohortID, ref ordersRGV);
                        bThis = false;
                    }
                    else
                        bThis = true;
                }
                tTargetSwitch = 9999999;
            }
            else if (nInvasion > 4)
            {
                foreach (Int32 cohortID in enemyCohorts)
                {
                    game.GetEnemyCohortData(cohortID, out cohortDbID, out cohortType);
                    if (cohortDbID == "ENEMY_GAUL_LT")
                        game.SetCohortOrders(cohortID, ref ordersRGV);
                    else if (bThis)
                    {
                        game.SetCohortOrders(cohortID, ref orders);
                        game.SetCohortTargets(cohortID, ref sTargets2);
                        bThis = false;
                    }
                    else
                    {
                        game.SetCohortOrders(cohortID, ref orders);
                        game.SetCohortTargets(cohortID, ref sTargets1);
                        bThis = true;
                    }
                }
                tTargetSwitch = 9999999;
            }
        }

        void OnCohortTargetDestroyed(IGameQueryInterface game)
        {
            if (nInvasion > 1)
            {
                String nextOrders = "RazeGovernorVilla";
                game.SetCohortOrders(game.RunCohortID, ref nextOrders);
            }
            else
            {
                Int32[] enemyCohorts;
                String invasion = "raid57AD";
                String[] sTargets = { "C4b infra Granary", "C4b infra Warehouse" };
                game.GetInvaderCohorts(ref invasion, out enemyCohorts);
                foreach (Int32 cohortID in enemyCohorts)
                    game.SetCohortTargets(cohortID, ref sTargets);
            }
            if (nPalace(game) == 0)
            {
                game.OpenTradeRoute(kDefeat);
                game.ScriptDone = true;
            }
        }

    }
}
